/**
 * @file	cf_stack.h
 * @author	myusgun <myusgun@gmail.com>
 *
 * @remark 스택
 *
 * @example stack.c
 */
#ifndef __CF_STACK_H__
#define __CF_STACK_H__

#include "cf_base.h"

typedef void *	CF_Stack_Ctx;

#ifdef __cplusplus
extern "C" {
#endif

CF_EXPORT int
CF_Stack_CreateCtx		(CF_Stack_Ctx * ctx);

CF_EXPORT int
CF_Stack_DestroyCtx		(CF_Stack_Ctx ctx);

CF_EXPORT int
CF_Stack_Push			(CF_Stack_Ctx	ctx,
						 const void		* element);

CF_EXPORT int
CF_Stack_Pop			(CF_Stack_Ctx	ctx,
						 void			** element);

CF_EXPORT int
CF_Stack_Top			(CF_Stack_Ctx 	ctx,
						 void			** element);

CF_EXPORT int
CF_Stack_GetSize		(CF_Stack_Ctx ctx);

#ifdef __cplusplus
}
#endif

#endif // #ifndef __CF_STACK_H__
